//https://www.youtube.com/BitaBit

//https://www.bitabittecnologia.com.br

//Exemplo para criar caracteres personalizados.

#include <LiquidCrystal.h>

int rs = 12; //Pino Register select
int e = 11;  //Pino Enable
int d4 = 5;  //Pino de dados d4
int d5 = 4;  //Pino de dados d5
int d6 = 3;  //Pino de dados d6 
int d7 = 2;  //Pino de dados d7

LiquidCrystal lcd(rs, e, d4, d5, d6, d7);

//Símbolos personalizados
byte coracao[8] = 
{
  B00000,
  B01010,
  B11111,
  B11111,
  B11111,
  B01110,
  B00100,
  B00000
};

byte seta_cima[8] =
{
  B00000,
  B00100,
  B01110,
  B11111,
  B01110,
  B01110,
  B01110,
  B00000
};

byte sorriso[8] = 
{
  B00000,
  B10001,
  B00000,
  B00000,
  B10001,
  B01110,
  B00000
};

byte cereja[8] = 
{
  B00010,
  B00100,
  B00100,
  B01110,
  B11111,
  B11111,
  B01110,
  B00000
};

byte aviao[8] = 
{
  B00000,
  B00100,
  B11111,
  B11111,
  B00100,
  B00100,
  B01110,
  B00000
};

byte espiral[8] = 
{
  B11111,
  B10000,
  B10111,
  B10101,
  B10101,
  B10101,
  B10001,
  B11111
};

byte zigzag[8] = 
{
  B11111,
  B00001,
  B11111,
  B10000,
  B11111,
  B00001,
  B11111,
  B00000
};

byte pontos[8] = 
{
  B10101,
  B01010,
  B10101,
  B01010,
  B10101,
  B01010,
  B10101,
  B01010
};

byte pontos2[8] = 
{
  B10101,
  B01010,
  B10101,
  B01010,
  B10101,
  B01010,
  B10101,
  B01010
};

void setup() 
{
  lcd.begin(16, 2); //LCD de 16 colunas e 2 linhas.

  //Cria o caractere e associa um endereço a ele.
  lcd.createChar(0, coracao); 
  lcd.createChar(1, seta_cima);
  lcd.createChar(2, sorriso);
  lcd.createChar(3, cereja);
  lcd.createChar(4, aviao);
  lcd.createChar(5, espiral);
  lcd.createChar(6, zigzag);
  lcd.createChar(7, pontos);

  lcd.setCursor(0, 0);
  //Ao fazer referência ao caractere personalizado "0" é necessário fazer o cast "(byte)0" devido o valor não estar em uma variável.
  lcd.write((byte)0); //Exibe o coração. 

  lcd.setCursor(1, 0);
  lcd.write(1); //Exibe a seta.

  lcd.setCursor(2, 0);
  lcd.write(2); //Exibe o sorriso.

  lcd.setCursor(3, 0);
  lcd.write(3); //Exibe a cereja.

  lcd.setCursor(4, 0);
  lcd.write(4); //Exibe o avião.

  lcd.setCursor(5, 0);
  lcd.write(5); //Exibe a espiral.

  lcd.setCursor(6, 0);
  lcd.write(6); //Exibe o zigzag.

  lcd.setCursor(7, 0);
  lcd.write(7); //Exibe os pontos.
}

void loop() 
{
  
}

